
/*
YAMP - Yet Another Matrix Program
Version: 1.6
Author: Mark Von Tress, Ph.D.
Date: 01/11/93  

Copyright(c) Mark Von Tress 1993
Portions of this code are (c) 1991 by Allen I. Holub and are used by
permission

DISCLAIMER: THIS PROGRAM IS PROVIDED AS IS, WITHOUT ANY
WARRANTY, EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED
TO FITNESS FOR A PARTICULAR PURPOSE. THE AUTHOR DISCLAIMS
ALL LIABILITY FOR DIRECT OR CONSEQUENTIAL DAMAGES RESULTING
FROM USE OF THIS PROGRAM.

*/


#include <stdio.h>
#include <stdlib.h>
#include <math.h>

double gammln(double xx);
double gammp(double x, double a, double b);
double ncbeta(double x, double a, double b, double lam);
double betai(double a, double b, double x);
double ncf(double f, double n1, double n2, double lam);
double probf(double f, double n1, double n2);
double probnormi(double u);
double probnorm(double x);
double ncfinv(double p, double v1, double v2, double lam);
double probfi(double p, double n1, double n2);
double nct(double t, double df, double nc);
double probt(double t, double n1);
double probti(double p, double df);
double ncti(double p, double df, double nc);
double ncgamma(double x, double a, double b, double lam);
double probchi(double x, double df);
double ncchi(double x, double df, double lam);
double ncgammai(double p, double a, double b, double lam);
double ncchii(double p, double a, double lam);
double probchii(double p, double df);
