;
; Startup file for notGNU emacs (notgnu.st).
; This form of file can be loaded at anytime using
; the extended command load-file.
;
; I like to make sure I don't edit a file in 2 places
; the default is NOT to check so this turns it on
;
(toggle-check-file-timestamp)
;
; My UNIX machines hate to see my C source with all those
; dang CR in them (network shared disks) - default is CR
; is written for all files, this disables CR from being written
; into .c, .h, .cpp and .hpp files.
;
(toggle-just-write-newline)
;
; Various keybindings to make me happy
;
; "\^x" is ctrl-x
; "\F1" is function key F1
; "\Eo" is meta-o (or ESC-o)
; "\Kp-+" is keypad +
; 

(global-set-key "\F1" 'goto-line)
(global-set-key "\F8" 'other-window)
(global-set-key "\E+" 'enlarge-window)
(global-set-key "\E-" 'shrink-window)
(global-set-key "\^z" 'scroll-one-line-up)
(global-set-key "\Ez" 'scroll-one-line-down)
;
; kinda matches VI % match function and gnu emacs
; ctrl-% match macro I defined
;
(global-set-key "\E5" 'goto-match)
(global-set-key "\^c" 'copy-region-as-kill)
;
; these at end since they will fail in DOS version
; because (1) shell-window is not a legal DOS command
; and (2) fkeys beyond 10 are not visible
;
(global-set-key "\F2" 'shell-window)
(global-set-key "\F9" 'make)
(global-set-key "\F10" 'next-error)
(global-set-key "\F12" 'undo-last-undoable)
