/*
 * Name:	Mg 2a
 *		MSDOS system header file (TurboC 1.5)
 */

/* can't include these, the ANSI style prototypes conflict with the
 * definitions in defs.h
 */
/* #include <stdlib.h> */
/* #include <string.h> */
/* #include <dir.h> */
/* #include <stdio.h> */

#ifndef NULL
# define NULL	0L
#endif

#if defined(MSW) || defined (MSC)
# define CONSTANT const
#else
# define NEAR
# define CONSTANT 
#endif

#define	KBLOCK	1024			/* Kill grow.			*/
#define	GOOD	0			/* Good exit status.		*/
#define	MAXPATH	256			/* Maximum length of path for chdir */

/*#define CRYPT*/			/* support encryption */
#define LOCAL_VARARGS			/* use sys/default/varargs.h */
#define DO_METAKEY			/* ALT acts like META */

#define METABIT 0x200

#define FKEYS				/* we have dedicated function keys */
/* #define NO_DIRED */			/* dired works now */
#define C_ALLOCA			/* used by regex, C version of alloca*/

typedef long	RSIZE;			/* Type for file/region sizes	*/
typedef short	KCHAR;			/* Type for internal keystrokes	*/


/*
 * Macros used by the buffer name making code.
 * Start at the end of the file name, scan to the left
 * until BDC1 (or BDC2, if defined) is reached. The buffer
 * name starts just to the right of that location, and
 * stops at end of string (or at the next BDC3 character,
 * if defined). BDC2 and BDC3 are mainly for VMS.
 */
#ifdef FAT
# define	BDC1	'\\'
#else
# define	BDC1	'/'
#endif

#define bcopy(s,d,n)	memcpy(d,s,n)	/* memory-to-memory copy	*/
#define bzero(s,n)	memset(s,0,n)	/* memory zero			*/

#define bcmp(s1,s2,n)	memcmp(s2,s1,n) /* memory comparison		*/

#ifdef MSC
# define fncmp	stricmp
#else
# define fncmp	strcmp
#endif

#define MALLOCROUND(m)	(m+=7,m&=~7)	/* round up to 8 byte boundry	*/

#ifdef MSW
# define getwd(cwd)	getcwd(cwd,NFILEN) /* get current working dir	*/
#endif

#ifdef MSC
# define getwd(cwd)	getcwd(cwd,NFILEN) /* get current working dir	*/
#endif

#ifdef HP
# define getwd(cwd)	getcwd(cwd,NFILEN) /* get current working dir	*/
#endif

#if defined(SVR4) || defined (SYSV)
# define getwd(cwd)	(char *)getcwd(cwd,NFILEN) /* get current working dir */
#endif

#define TABSTOP  8             /* we hate hard coded numbers, this is */
#define TABROUND (TABSTOP -1)  /* still bad but better */

/* incremental indenting
*/
#define INCSTEP 2
