#include "jam.h"
#include "def.h"

/*
 * This file contains the string that gets written
 * out by the emacs-version command.
 */
#ifdef MSW
# define VSTRING
  static char *emacsversion = "1.2a for Windows: (based on MG2a)";
#endif

#ifdef X11
# define VSTRING
  static char *emacsversion = "1.2a for X11: (based on MG2a)";
#endif

#ifndef WINDOWED
# define VSTRING
  static char *emacsversion = "1.2a: based on MG2a";
#endif

#ifndef VSTRING
  static char *emacsversion = "1.2a for Unix/curses- (based on MG2a)";
#endif

#ifdef __DATE__
  char sdate[] = ", "__DATE__;
#else
  char sdate[] = " approx. June 11, 1993";
#endif

/*
 * Display the version. All this does
 * is copy the version string onto the echo line.
 */
/*ARGSUSED*/
showversion(f, n)
int f, n;
{
  char str[NLINE];

  strcpy(str, getversion());
  strcat(str, sdate);
  ewprintf(str);
  return TRUE;
}
char *getversion()
{
  static char buf[NLINE];

  strcpy(buf, g_APPNAME);
  strcat(buf, " ");
  strcat(buf, emacsversion);
  return (buf);
}

char *shortversion()
{
  static char stuff[20] = {0};
  int i;

  if (stuff[0] == 0)
    for (i = 0; ; i++)
      {
        stuff[i] = emacsversion[i];
        if (emacsversion[i] == ' ')
          break;
      }

  return(stuff);
}    
