/*xxalloc.h**************************************************************/     
/*									*/
/*				xxalloc 				*/
/*									*/
/*			Placed in the public domain			*/
/*			 by Harold G. Walters 1988			*/
/*									*/
/*	Bug fixes, ect to walters@ce.okstate.edu until May 1989		*/
/*									*/
/*	This software is provided as is.  No claims are made for	*/
/*	this software regarding its fitness and/or correctness for	*/
/* 	any purpose.  Use of this software is at the user's own risk.	*/
/*									*/
/************************************************************************/

extern void xx_error();
extern char *xx_alloc();
extern void xx_free();
extern long xx_amount();

/* size n */
extern char *n1_alloc();
extern char *n1_renum();
extern void n1_free();
extern void n1_init();
extern void n1_prnt();
extern char **n2_alloc();
extern char **n2_renum();
extern void n2_free();
extern void n2_init();
extern void n2_prnt();
extern char ***n3_alloc();
extern char ***n3_renum();
extern void n3_free();
extern void n3_init();
extern void n3_prnt();

/* char */
extern char *c1_alloc();
extern char *c1_renum();
extern void c1_free();
extern void c1_init();
extern void c1_prnt();
extern char **c2_alloc();
extern char **c2_renum();
extern void c2_free();
extern void c2_init();
extern void c2_prnt();
extern char ***c3_alloc();
extern char ***c3_renum();
extern void c3_free();
extern void c3_init();
extern void c3_prnt();

/* short */
extern short *s1_alloc();
extern short *s1_renum();
extern void s1_free();
extern void s1_init();
extern void s1_prnt();
extern short **s2_alloc();
extern short **s2_renum();
extern void s2_free();
extern void s2_init();
extern void s2_prnt();
extern short ***s3_alloc();
extern short ***s3_renum();
extern void s3_free();
extern void s3_init();
extern void s3_prnt();

/* long */
extern long *l1_alloc();
extern long *l1_renum();
extern void l1_free();
extern void l1_init();
extern void l1_prnt();
extern long **l2_alloc();
extern long **l2_renum();
extern void l2_free();
extern void l2_init();
extern void l2_prnt();
extern long ***l3_alloc();
extern long ***l3_renum();
extern void l3_free();
extern void l3_init();
extern void l3_prnt();

/* int */
extern int *i1_alloc();
extern int *i1_renum();
extern void i1_free();
extern void i1_init();
extern void i1_prnt();
extern int **i2_alloc();
extern int **i2_renum();
extern void i2_free();
extern void i2_init();
extern void i2_prnt();
extern int ***i3_alloc();
extern int ***i3_renum();
extern void i3_free();
extern void i3_init();
extern void i3_prnt();

/* float */
extern float *f1_alloc();
extern float *f1_renum();
extern void f1_free();
extern void f1_init();
extern void f1_prnt();
extern float **f2_alloc();
extern float **f2_renum();
extern void f2_free();
extern void f2_init();
extern void f2_prnt();
extern float ***f3_alloc();
extern float ***f3_renum();
extern void f3_free();
extern void f3_init();
extern void f3_prnt();

/* double */
extern double *d1_alloc();
extern double *d1_renum();
extern void d1_free();
extern void d1_init();
extern void d1_prnt();
extern double **d2_alloc();
extern double **d2_renum();
extern void d2_free();
extern void d2_init();
extern void d2_prnt();
extern double ***d3_alloc();
extern double ***d3_renum();
extern void d3_free();
extern void d3_init();
extern void d3_prnt();

