/* keyname function strings 
*/
#ifdef KEYMAP_C
# define globalvar(variable, value) variable = value
#else
# define globalvar(variable, value) extern variable
#endif

/* various strings used in may places.
*/
#ifdef MSW
 globalvar(char *spawnfilename, "em$shl.log");
#else
 globalvar(char spawnfilename[NFILEN], {0});
#endif
globalvar(char *nosuchbuffer, "No such buffer.");
globalvar(char *Nobytes, "Can't get %ld bytes.");
globalvar(char *Scratch, "*scratch*");
globalvar(char *DiredStr, "dired");
globalvar(char *BlistStr, "blist");
globalvar(char *Impossible, "Impossible change.");
globalvar(char *Markset, "Mark set.");
globalvar(char *posFormat, " %d,%d ");  /* spaces needed! */
globalvar(char *garbage, "Garbage collecting...");
globalvar(char *notinmacro, "Not inside macro definition.");
globalvar(char *BUSY, "Busy!");
globalvar(char *modeerr, "Could not find mode: %s");

/* mouse stuff - abbreviated extended commands and some msgs
* (other msgs inside mouse.c)
*/
globalvar(char *LeftDwn, "l");
globalvar(char *LeftDwnShift, "sl");
globalvar(char *RightDwn, "r");
globalvar(char *DoubleClick, "dl");
globalvar(char *MoveStr, "m");
globalvar(char *LeftUp, "lu");
globalvar(char *MouseAbort, "ma");
globalvar(char *MouseTimer, "mt");

#if defined(X11) || defined(CURSES)  /* ie UNIX machines, sigh */
  globalvar(char *mktempTemplate, ".notgnuXXXXXX");
  globalvar(char *pastemsg, "Use Button 2 to paste text.");
#else /* Windows 3.*, NT, DOS, ?? */
  globalvar(char *pastemsg, "Use Right Button to paste text.");
#endif
