
!IFNDEF DEBUG
DEBUG = 0
!ENDIF

TARGET = NT
CPU = i386

PROJ = ntnot

DEF_FILE = emax.DEF
RES_FILE = ME.RES
RBJ_FILE = ME.RBJ
RC_FILE = ME.RC

#
# x86 build stuff
#
C_FLAGS = /DJAM /DMSW 
CC  = cl386 /Ic:\mstools\h
CFLAGS_G  = /G3 /Gd /BATCH /Di386=1 /DWIN32 /DWINNT=1 $(C_FLAGS)
CFLAGS_D  = /Od /Zi
CFLAGS_R  = /Os /Og
LFLAGS_G  = /SUBSYSTEM:windows /ENTRY:WinMainCRTStartup\
        /OUT:$(PROJ).exe $(L_FLAGS)
LFLAGS_D  = /DEBUG:full /DEBUGTYPE:cv
LFLAGS_R  = 
LIB = c:\mstools\lib
LLIBS_G   = $(LIB)\libcmt.lib $(LIB)\*.lib
LLIBS_R  =
LLIBS_D  =

MAPFILE_D  = $(PROJ).map
MAPFILE_R  = NUL
LINKER	= link
LRF  = echo > NUL
RC  = rc
RCFLAGS2  = /30 /t
CVFLAGS  = /25

FILES  = w3font.c mouse.c w3io.c w3key.c w3win.c w3mem.c \
    alloca.c basic.c buffer.c cinfo.c dir.c dired.c display.c \
    echo.c extend.c file.c fileio.c help.c kbd.c keymap.c \
    line.c macro.c main.c match.c modes.c paragrap.c \
    random.c regex.c region.c re_searc.c search.c spawn.c \
    ttyio.c ttykbd.c version.c window.c word.c dos.c undo.c indent.c \
    crypt.c w3ext.c w3misc.c

OBJ_FILES = w3font.obj w3io.obj w3key.obj w3ext.obj \
    w3win.obj w3mem.obj \
    alloca.obj basic.obj buffer.obj cinfo.obj \
    dir.obj dired.obj display.obj \
    echo.obj extend.obj file.obj fileio.obj \
    help.obj kbd.obj keymap.obj \
    line.obj macro.obj main.obj match.obj \
    modes.obj paragrap.obj \
    random.obj regex.obj region.obj \
    re_searc.obj search.obj spawn.obj \
    ttyio.obj ttykbd.obj version.obj \
    window.obj w3misc.obj\
    word.obj dos.obj undo.obj \
    indent.obj crypt.obj mouse.obj

all: $(PROJ).exe

.SUFFIXES:
.SUFFIXES: .obj .c
.SUFFIXES: .obj .c


$(RES_FILE) : $(RC_FILE) 
        $(RC) /r /fo $(RES_FILE) $(RC_FILE)
        cvtres -$(CPU) $(RES_FILE) -o $(RBJ_FILE)

$(RBJ_FILE): $(RES_FILE)

$(PROJ).exe : $(OBJ) $(OBJ_FILES) $(RBJ_FILE)
    $(LINKER) /OUT:$(PROJ).exe $(OBJ_FILES) $(RBJ_FILE)  /MACHINE:$(CPU)\
    $(LIBS) $(LLIBS_G) $(LLIBS_R) $(LFLAGS_G) $(LFLAGS_R)

.c.obj :
  $(CC) /c $(CFLAGS_G) /W3 $*.c


